<?php
define("CLIENTAREA",false);
require_once("../../../../init.php");
session_start();
require_once("../alipay-sdk/AopSdk.php");
use \Illuminate\Database\Capsule\Manager as Capsule;
$appid = Capsule::table('tbladdonmodules')->where('setting','alipay_appid')->first()->value;
$alipay_key = Capsule::table('tbladdonmodules')->where('setting','alipay_key')->first()->value;
$rsa_key = str_replace(["\r", "\n", "-----BEGIN RSA PRIVATE KEY-----", "-----END RSA PRIVATE KEY-----"],"",Capsule::table('tbladdonmodules')->where('setting','alipay_rsa_key')->first()->value);
function alipayMessage($status = 'error', $message = '无返回信息'){
	$companyname = \WHMCS\Config\Setting::getValue('CompanyName');
	include_once 'return.php';
	exit();
}
$auth_code = trim($_REQUEST['auth_code']);
$AopClient = new AopClient();
$AopClient->gatewayUrl = 'https://openapi.alipay.com/gateway.do';
$AopClient->appId = $appid;
$AopClient->rsaPrivateKey = $rsa_key;
$AopClient->alipayrsaPublicKey=$alipay_key;
$AopClient->apiVersion = '1.0';
$AopClient->signType = 'RSA2';
$AopClient->postCharset='utf-8';
$AopClient->format='json';
include_once '../alipay-sdk/aop/request/AlipaySystemOauthTokenRequest.php';
$request = new AlipaySystemOauthTokenRequest();
$request->setGrantType("authorization_code");
$request->setCode($auth_code);
$result = $AopClient->execute($request);
$access_token = $result->alipay_system_oauth_token_response->access_token;
include_once '../alipay-sdk/aop/request/AlipayUserInfoShareRequest.php';
$request = new AlipayUserInfoShareRequest();
$result = $AopClient->execute($request,$access_token);
$responseNode = str_replace(".", "_", $request->getApiMethodName()) . "_response";
$resultCode = $result->$responseNode->code;
if(!empty($resultCode)&&$resultCode == 10000){
	$user_data = $result->$responseNode;
}else{
	alipayMessage('error','用户信息获取失败');
}

$nikename = $user_data->nick_name;
$avatar = $user_data->avatar;
$oid = $user_data->user_id;

$openID = Capsule::table('mod_alipayconnect')->where('openid', $oid)->first();

if($openID){
    
    $uid = $openID->uid;
	
	// 更新内容到数据库
	Capsule::table('mod_alipayconnect')->where('uid', $uid)->update([
		'nickname' 	=> $nikename,
		'avatar'	=> $avatar,
		'openid'	=> $oid
	]);
    
    // 写入 SESSION UID
    $_SESSION['uid'] = $uid;
	
	// 获取 UID
	$userinfo 	= Capsule::table('tblclients')->where('id', $uid)->first();
	$username 	= $userinfo->firstname . ' ' . $userinfo->lastname;
	
	// 取出值
	$login_uid 	= $userinfo->id;
	$login_pwd 	= $userinfo->password;
	$language 	= $userinfo->language;

	// 更新登录时间登录IP
	$fullhost = gethostbyaddr($remote_ip);
	Capsule::table('tblclients')->where('id', $login_uid)->update([
		'lastlogin' 	=> date("Y-m-d H:i:s"),
		'ip'			=> $remote_ip,
		'host'			=> $fullhost
	]);
	$_SESSION['uid'] = $login_uid;
	if ($login_cid) {
		$_SESSION['cid'] = $login_cid;
	}
    $haship = $CONFIG['DisableSessionIPCheck'] ? '' : \WHMCS\Utility\Environment\CurrentUser::getIP();
    $whmcsVersion = \WHMCS\Config\Setting::getValue('Version');
    //$Version = strpos($whmcsVersion,'7.3.0');
	$VersionT = explode(".",$whmcsVersion);
	$Version = $VersionT[0].'.'.$VersionT[1];
	// 写入登录数据 判断是否版本大于 7.3.0
	if($Version > '7.3'){
    	$_SESSION['upw'] = \WHMCS\Authentication\Client::generateClientLoginHash($login_uid, $login_cid, $login_pwd);
	}elseif($Version == '7.3' && @$VersionT[3] > '0'){
		$_SESSION['upw'] = \WHMCS\Authentication\Client::generateClientLoginHash($login_uid, $login_cid, $login_pwd);
	} else {
		//7.3以下版本未经测试,待修正
    	$_SESSION['upw'] = sha1($login_uid . $login_pwd . $haship . substr(sha1($cc_encryption_hash),0,20));
	}
	$_SESSION['tkval'] = genRandomVal();
	if ($language) {
		$_SESSION['Language'] = $language;
	}
	$hookParams = array('userid' => $login_uid);
	$hookParams['contactid'] = $login_cid ? $login_cid : 0;
	run_hook('ClientLogin', $hookParams);
	logActivity( $username . ' - 通过 alipay 登录' );
	$loginsuccess = true;
    alipayMessage('success', '登录成功！');
	
}else{
	if ( $_SESSION['uid'] ) {	
		Capsule::table('mod_alipayconnect')
        ->insert(array(
        	'uid'		=> $_SESSION['uid'],
        	'openid' 	=> $oid,
        	'nickname'	=> $nikename,
        	'avatar'	=> $avatar
        ));
		alipayMessage('success', '关联成功！');
	} else {
	    alipayMessage('error', '尚未绑定alipay<br/>请前往用户中心进行绑定');
	}
	
}